﻿/////////////////////////////////////////////////////////
// Gameboy shader effect
varying mediump vec2 vTex; //Texture coord
uniform lowp sampler2D samplerFront; //Texture

void main(void)
{
	lowp vec4 image = texture2D(samplerFront, vTex);
	lowp float graySample = image.r * 0.299 + image.g * 0.587 + image.b * 0.114; //Luminosity formula
	
	graySample = graySample; //Sampling first to grayscale to map the luminosity value with a 4 color gameboy pallette
		
	lowp vec4 gb;
	
	if (graySample>0.75)
		gb = vec4(0.6078,0.7273,0.0588,image.a); //155,188,15 Brightest
	else if (graySample>0.50)
		gb = vec4(0.5450,0.6745,0.0588,image.a); //139,172,15
	else if (graySample>0.25)
		gb = vec4(0.1882,0.3843,0.1882,image.a); //48,98,48
	else 
		gb = vec4(0.0588,0.2196,0.0588,image.a); //15,56,15 Darkest

	gl_FragColor = vec4(gb.rgb,image.a);
}
